# README #

    (**************************************************************)
    (*   Copyright Dominique Larchey-Wendling [*]                 *)
    (*                                                            *)
    (*                             [*] Affiliation LORIA -- CNRS  *)
    (**************************************************************)
    (*      This file is distributed under the terms of the       *)
    (*         CeCILL v2 FREE SOFTWARE LICENSE AGREEMENT          *)
    (**************************************************************)

### What is this repository for? ###

* This repository is about a formal intuitionistic Coq proof of the Kruskal tree theorem without
  any of the restrictions that occur in other existing proofs such as:

    + the assumption of the decidability of the ground relation as in Monica Seisenberger's work;

    + or any added axiom, like Brouwer's Thesis as in Wim Veldman's work.

    + I plan to investigate a draft of a type theoretic proof given to me by Thierry Coquand
      to see if I could obtain the same results that way.

* This proof is purely based on intuitionistic reasoning with inductive predicates and thus, 
  cannot be compared to shorter (and easier) classical proofs such as those based on the 
  Nash-William's *minimal bad-sequence argument* (see Christian Sternagel paper and proof in 
  Isabelle/HOL)

* In a way, it can be seen as a generalization of the work of Daniel Fridlender on Higman's Lemma 
  but it is much more complicated. It is a combination of the proof principle's used by Wim Veldman 
  (like the *Fan Theorem*, the *Combinatorial Principle* and the *Evaluation maps*)
  with the definition of *Almost Full* relations proposed by Thierry Coquand and his intuitionistic
  proof of *Ramsey's Theorem* (actually, an equivalent form a Ramsey's theorem is proved in Daniel 
  Fridlender's thesis, using inductively defined Bars).

* See the source file [readme.v](readme.v) for quick description of what is actually proved.

### How do I get set up? ###

* This should compile with Coq 8.4pl4 (with "make").

### Who do I talk to? ###

* This proof implemented by [Dominique Larchey-Wendling](http://www.loria.fr/~larchey)
